
%option prefix="fixc_" nounput reentrant bison-bridge noyywrap yylineno outfile="lex.yy.c" header="../scanner.h"

%{

#include <string.h>
#include <stdlib.h>
#include "grammar.h"
#include "pure.h"
#define YY_NO_INPUT

%}

%x PRE INC COMMENTCPP COMMENTC

%%

\#			{ECHO; BEGIN PRE;}

\/\/			{ECHO; BEGIN COMMENTCPP;}
\/\*			{ECHO; BEGIN COMMENTC;}

<COMMENTCPP>\n		{ECHO; BEGIN INITIAL;}
<COMMENTCPP>.		{ECHO;}

<COMMENTC>\*\/		{ECHO; BEGIN INITIAL;}
<COMMENTC>\n		{ECHO;}
<COMMENTC>.		{ECHO;}

<PRE>\\\n		{ECHO; }
<PRE>include		{ECHO; BEGIN INC; return INCLUDE;}
<PRE>[ \r\t]		{ECHO;}
<PRE>\n			{ECHO; BEGIN INITIAL;}
<PRE>.			{ECHO; BEGIN INITIAL;}

<INC>\\\n		{ECHO;}
<INC>\"[^\"]*\"         {BEGIN PRE; yylval->s = strdup(yytext); return STRING;}
<INC>\<[^\>]*\>         {BEGIN PRE; yylval->s = strdup(yytext); return STRING;}
<INC>[A-Za-z0-9_]*      {ECHO; BEGIN PRE; return DEFINE;}
<INC>[ \t]		{ECHO;}
<INC>.			{ECHO; return NEWLINE;}
<INC>\n			{ECHO; return NEWLINE;}

\"[^\"]*\"              {ECHO;}


\n			{ECHO;}
.                       {ECHO;}

%%

